<?php
/***************************************************************
*  Copyright notice

*  (c) 2011 
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 3 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 *
 * author   Snke Trunk <trunk@beans-n-bites.de.de>
 * @package bnbbackupext
 * @version 0.9 
 * @license http://www.gnu.org/licenses/lgpl.html GNU Lesser General Public License, version 3 or later
 *
 */
 
 
 
class Tx_Bnbbackupext_Controller_BnbbackupController extends Tx_Extbase_MVC_Controller_ActionController {

	/**
	 * bnbbackupRepository
	 *
	 * @var Tx_Bnbbackupext_Domain_Repository_BnbbackupRepository
	 */
	protected $bnbbackupRepository;
	protected $backup_dir;	
	protected $import_dir;		
	protected $extern_dir;			
	protected	$Path = '../typo3conf/ext/bnbbackupext/Resources/Private/backups/';
	protected $TargetFileName;
	protected $configuration;
	protected $errors;
	protected $showErrors;

	/**
	 * injectBnbbackupRepository
	 *
	 * @param Tx_Bnbbackupext_Domain_Repository_BnbbackupRepository $bnbbackupRepository
	 * @return voidy
	 */
	public function injectBnbbackupRepository(Tx_Bnbbackupext_Domain_Repository_BnbbackupRepository $bnbbackupRepository) {
		$this->bnbbackupRepository = $bnbbackupRepository;
	}

	/**
	 * action list
	 *
	 * @return string The rendered list action
	 */
	public function listAction() {
		global $BE_USER;		
		$this->configuration = $this->configurationManager->getConfiguration(Tx_Extbase_Configuration_ConfigurationManagerInterface::CONFIGURATION_TYPE_FRAMEWORK);		
				
		
		$this->PathMysqlDump = $this->configuration['persistence']['PathMysqlDump'];
		
 		$this->flashMessageContainer->flush();

		for($i = 1; $i < 5; $i++) 		
		{
	 		if(!empty($this->configuration['persistence']['customTables'.$i]))
 			{ 			
				$this->view->assign('LabelCustomTables'.$i, $this->configuration['persistence']['LabelCustomTables'.$i]);		   					 		
				$this->view->assign('showCustomTables'.$i, 1);		   
				$this->view->assign('TableList'.$i, $this->configuration['persistence']['customTables'.$i]);		   
			}	
		}	
		if($this->configuration['persistence']['importAdminOnly'])	
		{
			if($BE_USER->user["admin"])
					$this->view->assign('admin',1);				
		}
		else			
			$this->view->assign('admin',1);				
		
		
		$this->TargetFileName =  "[TYP]_";
		$this->TargetFileName .=  date ("Y",time())."_";
		$this->TargetFileName .=  date ("m",time())."_";
		$this->TargetFileName .=  date ("d",time())."_";
		$this->TargetFileName .=  date ("H",time());
		$this->TargetFileName .=  date ("i",time());	
		$this->TargetFileName .=  date ("s",time());		
		
		if(!is_dir($this->Path))
			mkdir($this->Path);
			
		$this->backup_dir = $this->Path.'mysql';
		if(!is_dir($this->backup_dir))
			mkdir($this->backup_dir);
				
		$this->import_dir = $this->Path.'import';
		if(!is_dir($this->import_dir))
			mkdir($this->import_dir);
				
		$this->extern_dir = $this->Path.'extern';
		if(!is_dir($this->extern_dir))
			mkdir($this->extern_dir);
			
		if ($this->request->hasArgument('mysql_backup')){			
			$this->createBackupFile();
		}		
		else if( t3lib_div::GPvar('Upload') != "")	{	
			$this->fileUpload();
		}
		else if($this->request->hasArgument('export_files')){			
			$this->createExportExternfiles();
		}				
		//Datei importieren
		else if ($this->request->hasArgument('importfile')) {		
			$this->importFile();
		}
		else if ($this->request->hasArgument('delete')) {						
			$this->deleteFile();
		}
		
		
		$this->listDatabaseBackupfiles();
	 	$this->listDatabaseImportfiles();
 		$this->listExternfiles();			
			
		$this->view->assign('ErrorMessage',$this->errors);		   				
		$this->view->assign('showErrors',$this->showErrors);		   						


}
	
/***************************************************************************************************
create 	database backup
*****************************************************************************************************/
	public function createBackupFile() {	
		if($this->request->getArgument('mysql_backup') == "complete")	{
			$command = $this->PathMysqlDump.'mysqldump --add-drop-table   --opt -h  '.TYPO3_db_host.' --user='.TYPO3_db_username.'  --pass='.TYPO3_db_password;  
			$command .= ' --ignore-table='.TYPO3_db.'.  '.TYPO3_db.'	> '.$this->backup_dir.'/backup-file.sql';					
			$this->TargetFileName = str_replace("[TYP]","complete",$this->TargetFileName);
		}
					
		for($i = 1; $i < 5; $i++){			
			if($this->request->getArgument('mysql_backup') == 'custom'.$i){			
				$tables=explode(",",trim($this->configuration['persistence']['customTables'.$i]));
				$tables=implode(" ",$tables);
				$command = $this->PathMysqlDump.'mysqldump --add-drop-table   --opt -h  '.TYPO3_db_host.' --user='.TYPO3_db_username.'  --pass='.TYPO3_db_password;  
				$command .= ' '.TYPO3_db;	
				$command .= "  $tables ";
				$command .= ' > '.$this->backup_dir.'/backup-file.sql';	
						
				$filename = str_replace(" ","_",$this->configuration['persistence']['LabelCustomTables'.$i]);
				$filename = str_replace("/","_",$filename);
				$filename = str_replace("[","_",$filename);
				$filename = str_replace("]","_",$filename);
									
				$this->TargetFileName = str_replace("[TYP]",$filename,$this->TargetFileName);												
			}
		}	

		system($command,$error);

		if($error === 0) 		
	  	$this->flashMessageContainer->add('Backupfile has been created.');			
	  else if($error > 0) 	
			$this->addErrorMessage("An error occured while running mysqldump. Errorcode ($error)");
	  else
 			$this->addErrorMessage("Error creating backupfile. Maybe running php-function 'system' is not permitted on this server $error");
	  		
			
		$dir = getcwd();
		chdir($this->backup_dir);
		$tarfile = 	$this->TargetFileName."_".TYPO3_db.".zip";		
		$command = "zip -r $tarfile backup-file.sql";

		exec($command,$var);	
		chdir($dir);
		unlink($this->backup_dir."/backup-file.sql");			
	}
/***************************************************************************************************
backup external files
*****************************************************************************************************/		
	public function createExportExternfiles(){		
		$dir = getcwd();
		$source = explode(",",trim($this->configuration['persistence']['saveDirs']));
			
		$this->Path="../";									
		chdir($this->Path);
		$tarfile = str_replace("[TYP]","external_files",$this->TargetFileName);			
			
		foreach($source as $source)	{
			$command = "zip -r $tarfile $source";
				
			system($command,$error);				
				
			if($error > 0){
				$this->addErrorMessage("An error occured while running 'zip'");				
				break;
			}	
		 	else if(!isset($error)){		  	
				$this->addErrorMessage("Error creating backupfile. Maybe running php-function 'system' is not permitted on this server");						 		
	 			break;
		 	}	
		}
		$target = PATH_typo3conf."ext/bnbbackupext/Resources/Private/backups/extern/".$tarfile.".zip";	
				
		if(copy($tarfile.".zip",$target) === FALSE)
			$this->addErrorMessage("Error copy file to $target");								
		else if($error === 0) 			
	 		$this->flashMessageContainer->add('Backupfile has been created.');			
			
		unlink($tarfile.".zip");			
		chdir($dir);						
	}	
/***************************************************************************************************
file upload
*****************************************************************************************************/		
public function fileUpload(){
	$filename=$_FILES['userfile']['name'];
	if(move_uploaded_file( $_FILES['userfile']['tmp_name']  , $this->import_dir."/".$filename) === TRUE)						
 		$this->flashMessageContainer->add("Upload successfull");			
 	else
 		$this->errors .= "Could not write uploaded file to ".$this->import_dir."/".$filename;														
 			
	}				
/***************************************************************************************************
delete Backup  files
*****************************************************************************************************/			
public function deleteFile(){		
		if ($this->request->hasArgument('deletefiledown')) {		
			if(is_file($this->backup_dir."/".$this->request->getArgument('deletefiledown'))) {
				unlink($this->backup_dir."/".$this->request->getArgument('deletefiledown'));
				$this->flashMessageContainer->add("File '".$this->request->getArgument('deletefiledown')."' has been deleted");								
			}	
		}	
		else if ($this->request->hasArgument('deletefileimp')) {		
			if(is_file($this->import_dir."/".$this->request->getArgument('deletefileimp'))){
				unlink($this->import_dir."/".$this->request->getArgument('deletefileimp'));
				$this->flashMessageContainer->add("File '".$this->request->getArgument('deletefileimp')."' has been deleted");												

			}	
		}	
		else if ($this->request->hasArgument('deletefileext')) {
			if(is_file($this->extern_dir."/".$this->request->getArgument('deletefileext'))){
				unlink($this->extern_dir."/".$this->request->getArgument('deletefileext'));							
				$this->flashMessageContainer->add("File '".$this->request->getArgument('deletefileext')."' has been deleted");															
			}					
		}	
	}	

/***************************************************************************************************
import file
*****************************************************************************************************/		
public function importFile(){
	if(is_file($this->import_dir."/".$this->request->getArgument('importfile'))){
		$filename = $this->request->getArgument('importfile');
		$info=pathinfo($this->import_dir."/".$filename);
					
		if(strtolower($info["extension"]) == "zip"){
			$command = "unzip ".$this->import_dir."/".$filename." -d ../typo3conf/ext/bnbbackupext/Resources/Private/backups/import" ;													
			
			system($command,$error);				
			
		if($error > 0){
				$this->addErrorMessage("An error occured while running 'unzip'");				
				return;
			}	
		 	else if(!isset($error)){		  	
				$this->addErrorMessage("Error import backupfile. Maybe running php-function 'system' is not permitted on this server");						 		
	 			return;
		 	}											
			
			//das ist die ausgepackte Datei
			$filename = "backup-file.sql";							
		}
			
	$command = 'mysql -p -h '.TYPO3_db_host.'  --user='.TYPO3_db_username.'  --pass='.TYPO3_db_password.' '.TYPO3_db.' < "'.$this->import_dir.'"/'.$filename ;  

	unset($error);
	
	system($command,$error);	
	
	if($error > 0)
		$this->addErrorMessage("An error occured while running 'mysql' Errorcode ($error)");				
 	else if(!isset($error))		  	
		$this->addErrorMessage("Error creating backupfile. Maybe running php-function 'system' is not permitted on this server");						 		
 	else
		$this->flashMessageContainer->add($this->request->getArgument('importfile').'  has been imported'.$error); 	
		
	unlink($this->import_dir."/backup-file.sql");
	}				
}				

/***************************************************************************************************
list database backups
*****************************************************************************************************/		
public function listDatabaseBackupfiles()
{		
	if($handle = opendir($this->backup_dir)) {			
		$str="";
    $i=0;
		while (false !== ($file = readdir($handle))) {
	   	if(is_file($this->backup_dir."/".$file)){		    		
    		$filesize= round((filesize($this->backup_dir."/".$file))/1024);
		    		
				if($filesize == 0)
					$label="Warning Backup is empty: ";
				else	
					$label="";
  	    		
     		$files[$i]["label"] = $label;
     		$files[$i]["size"] = $filesize;
     		$files[$i]["file"] = rawurlencode($file);
   	    		
     		$i++;
	 	  }  
	  }
	closedir($handle);
	}		
		
	$this->view->assign('files', $files);		   					
		
	if(isset($files))
		$this->view->assign('BackupFileExist', 1);		   					
}

/***************************************************************************************************
list database imports
*****************************************************************************************************/		
public function listDatabaseImportfiles(){			
	if($handle = opendir($this->import_dir)) {
		$str="";				
    $i = 0;
		while (false !== ($file = readdir($handle))) {
		 	if(is_file($this->import_dir."/".$file)){
		 		$filesize= round((filesize($this->import_dir."/".$file))/1024);
		    		
				if($filesize == 0)
					$label="Warning Backup is empty: ";
				else	
					$label="";
									    			   	    				
   	 		$impfiles[$i]["label"] = $label;
   	 		$impfiles[$i]["size"] = $filesize;
   	 		$impfiles[$i]["file"] = rawurlencode($file);   	    		
   	    		
   	 		$i++;
	  	  }  
		  }
    closedir($handle);
		}
		
		if(isset($impfiles))
			$this->view->assign('ImportFileExist', 1);		   					
		
		$this->view->assign('impfiles', $impfiles);		   							
}		

/***************************************************************************************************
list database imports
*****************************************************************************************************/		
public function listExternfiles()
{		
	//Externeliste		
	$fileok=0;	
	$i=0;
	if($handle = opendir($this->extern_dir)) {
    $str="";				
		while (false !== ($file = readdir($handle))) {
    	if(is_file($this->extern_dir."/".$file)){
   		  $str.= '<li>'.$label.$file.'  <a href="download.php?downloadfile='.rawurlencode($file)."&dir=extern".'">download</a> <a  href="'.$_SERVER["SRIPT_NAME"].'?deletefileextern='.rawurlencode($file).'">lschen</a></li>';
    		$fileok=1;	    	    
    		
   	    $extfiles[$i]["label"] = $label;
   	    $extfiles[$i]["size"] = $filesize;
   	    $extfiles[$i]["file"] = rawurlencode($file);   	    		
   	    $i++;   	    		   	    		
   	  }  
   }  		   
   closedir($handle);
	}
		
  $this->view->assign('extfiles', $extfiles);		   							
		
	if($fileok==1)
		$this->view->assign('ExternFilesExist', 1);		   					
}
/***************************************************************************************************
add error Message
*****************************************************************************************************/		
public function addErrorMessage($errorMessage){
 		$this->errors .= '<li>'.$errorMessage.'</li>';														
 		$this->showErrors = 1; 			
	}						
}

?>